/***********************************************************************************
BEURTEILUNG von 9999999 für Aufgabe 3: 99 Punkte - 15=F

factMinus      (max. 8): 99 - Innenrekursion passt, Außenrekursion geht nicht in Außenrekursion über, berechnet banal (m-1)!.
factMinusArray (max. 8): 99 - quasileer
printArray     (max. 6): 99 - einzelne lines nicht auf null überprüft
main           (max. 3): 99 - na gut...

Hier ist ein Beispiel für eine Lösung (ohne Kommentare):

    public static long factMinus(final int m, final int n) {
        if (m == n) {
            if (n == 1) {
                return 1;
            }
            return n * factMinus(n - 1, n - 1);
        }
        return factMinus(m, n + 1) - factMinus(n, n);
    }

    public static long[][] factMinusArray(int n) {
        long[][] result = new long[n][];
        result[0] = new long[]{ 1 };
        for (int i = 1; i < n; i++) {
            result[i] = new long[i + 1];
            result[i][0] = (i + 1) * result[i - 1][0];
            for (int j = 1; j <= i; j++) {
                result[i][j] = result[i][j - 1] - result[i - j][0];
            }
        }
        return result;
    }

    public static void printArray(long[][] array) {
        if (array != null) {
            for (long[] line : array) {
                if (line != null) {
                    for(long v : line) {
                        System.out.print(v + ",");
                    }
                    System.out.println();
                }
            }
        }
    }

    public static void main(String[] args) {
        System.out.println(factMinus(2,2));
        System.out.println(factMinus(3,3));
        System.out.println(factMinus(4,4));
        System.out.println(factMinus(4,3));
        System.out.println(factMinus(4,2));
        printArray(factMinusArray(10));
    }

***********************************************************************************/
public class RecursionAndArrays {

    /*
    Aufgabe:
        Ergänzen Sie fehlende Teile der Methoden entsprechend den Kommentaren an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 25):
        8 Punkte für factMinus
        8 Punkte für factMinusArray
        6 Punkte für printArray
        3 Punkte für main
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */


    // We assume m >= n and n >= 1.
    // If m == n, then factMinus(m,n) returns the factorial of m, this is m! or 1 * 2 * ... * m.
    // If m > n, then factMinus(m,n) returns the factorial of m minus the sum of the factorials of all values in the
    // range between n and m - 1, this is m! - (m-1)! - ... - n!.
    // The implementation is recursive; no loop is used in the implementation.
    public static long factMinus(final int m, final int n) {

        if (m == n) {
            return m-1 > 0 ? m * factMinus(m-1, m-1) : 1;
        } else {
            long temp = factMinus(m-1,m-1);
            return temp; // TODO: Implementation is your task
        }
        // Additional methods can be used if they do not contain loops (although no additional method is necessary).
    }



    // factMinusArray(n) returns an array containing the following values (assuming x to be the name of the array):
    //     x[i][0] is (i + 1)!, this is 1 * 2 * ... * i * (i + 1), where 0 <= i and i < n;
    //     x[i][j] is x[i][j - 1] - x[i - j][0], where where 0 <= i and i < n and 0 < j and j <= i.
    // The array contains only these specified values, no additional values.
    // For example, using printArray as described below, printArray(factMinusArray(4)) shall produce this output:
    //     1,
    //     2,1,
    //     6,4,3,
    //     24,18,16,15,
    // There are loops in the implementation; the implementation is not recursive.
    public static long[][] factMinusArray(int n) {
        long[][] result = new long[4][4];
        return null; // TODO: Implementation is your task
        // Additional non-recursive methods can be used (although they are not necessary), but no recursive ones.
    }


    // printArray produces output showing the values in the array given as parameter. There is a separate line for
    // each index in the first dimension. Each value is followed by ",". The description of factMinusArray gives an
    // example. printArray does nothing if its parameter is null. No line is printed if the corresponding part of
    // the array is null.
    public static void printArray(long[][] array) {
        if (array != null) {
            String result = "";
            for (int i = 0; i < array.length; i++) {
                for (int j = 0; j < array[i].length; j++) {
                    result += array[i][j] + ",";
                }
                System.out.println(result);
                result = "";
            }
        }
        // TODO: Implementation is your task
    }


    // An execution of main does the following (in the given ordering):
    //   - Print a line showing the result of factMinus(2,2).
    //   - Print a line showing the result of factMinus(3,3).
    //   - Print a line showing the result of factMinus(4,4).
    //   - Print a line showing the result of factMinus(4,3).
    //   - Print a line showing the result of factMinus(4,2).
    //   - Invoke printArray with the result of factMinusArray(10).
    public static void main(String[] args) {
        // TODO: Implementation is your task
        System.out.println(factMinus(2, 2) + "");
        System.out.println(factMinus(3, 3) + "");
        System.out.println(factMinus(4, 4) + "");
        System.out.println(factMinus(4, 3) + "");
        System.out.println(factMinus(4, 2) + "");

        // zumindest printArray funktioniert
        // eigentlich sollte dort folgendes stehen:
        //      printArray(factMinusArray(10));
        long[][] xxx = {{1L},{2L,3L}, {4L, 5L, 6L}};
        printArray(xxx);
    }

}


